package controller;


import exception.GameControllerException;
import javafx.animation.KeyFrame;
import javafx.animation.Timeline;
import javafx.application.Platform;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;

import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.input.MouseButton;
import javafx.scene.input.MouseEvent;
import javafx.scene.paint.Color;
import javafx.stage.Stage;
import javafx.util.Duration;
import org.apache.commons.lang3.StringUtils;
import org.apache.commons.lang3.math.NumberUtils;
import scenerie.CircleModel;
import model.GameScore;
import model.GameScoreList;
import model.Score;
import model.ScoreList;


import java.io.IOException;
import java.net.URL;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.*;
import java.util.Timer;

/**
 * @author stefan.hohl
 * @version 26.06.2020
 */
public class GameController implements Initializable {
    @FXML
    private Label showCountDown, sizeLabel, delayLabel, repetitionsLabel;

    @FXML
    private Button start, advSettings, endTraining, subSettings, subSettings1;

    @FXML
    private Canvas canvas;

    @FXML
    private TextField sizeText, delayText, repetitionsText;

    private GraphicsContext graphicsContext;

    private CircleModel circleModel;

    private GameScoreList gameScoreList;

    private int interval;
    private Timer timer;
    private Timeline tl;
    private int amountMissed;
    private long timestamp = 0;
    private int delayMain;


    private boolean countDownOver = false;
    private boolean firstUserInput = false;

    private int showAmount;
    private int showAmountControl;

    private double sizeMain;
    private Score score;

    public GameController() {
        this.circleModel = new CircleModel(50, 50, 50);
        this.tl = new Timeline();
        showAmount = 30;
        gameScoreList = new GameScoreList();
        delayMain = 1000;
        sizeMain = circleModel.getRadius();
        this.score = new Score();
        showAmountControl = 30;


    }


    @FXML
    private void startTraining(ActionEvent event) {
        start.setVisible(false);
        graphicsContext.clearRect(0, 0, 1112, 510);
        graphicsContext.setFill(Color.web("#ccfcdd"));


        int delay = 1000;
        int period = 1000;
        timer = new Timer();
        interval = 3;
        timer.scheduleAtFixedRate(new TimerTask() {


            public void run() {
                Platform.runLater(() -> {

                    showCountDown.setText(Integer.toString(setInterval() + 1));


                });

            }
        }, delay, period);

    }

    public void startThisShit() {
        System.out.println("hi :)");
        gameProgress();
        tl.play();
    }

    @FXML
    private void clickAction(MouseEvent event) {

        if (circleModel.getyPos() <= event.getY() && circleModel.getyPos() + circleModel.getRadius() * 2 >= event.getY() && circleModel.getxPos() <= event.getX() && circleModel.getxPos() + circleModel.getRadius() * 2 >= event.getX()) {
            graphicsContext.clearRect(0, 0, 1112, 510);

            if (showAmount >= 0) {

            } else {
                tl.stop();
            }
        } else {
            amountMissed++;
        }
        if (timestamp != 0) {
            long calcTime = System.currentTimeMillis() - timestamp;
            System.out.println(calcTime);
            if (firstUserInput) {
//
                gameScoreList.addGameScore(new GameScore(calcTime));

            } else {
                firstUserInput = true;
            }
        }


    }

    public void makeRandomCircle() {
        showAmount--;

        System.out.println(showAmount);

        Random r = new Random();

        double y = (460 - circleModel.getRadius()) * r.nextDouble();
        double x = (1062 - circleModel.getRadius()) * r.nextDouble();

        graphicsContext.clearRect(0, 0, 1112, 510);
        circleModel.setyPos(y);
        circleModel.setxPos(x);
        circleModel.setRadius(sizeMain);
        graphicsContext.setFill(Color.web("#4dbd4a"));
        graphicsContext.fillOval(circleModel.getxPos(), circleModel.getyPos(), circleModel.getRadius() * 2, circleModel.getRadius() * 2);

    }

    public void makeVis() {

        advSettings.setVisible(false);
        endTraining.setVisible(false);
        sizeLabel.setVisible(true);
        sizeText.setVisible(true);
        delayLabel.setVisible(true);
        delayText.setVisible(true);
        repetitionsLabel.setVisible(true);
        repetitionsText.setVisible(true);
        subSettings.setVisible(true);
        subSettings1.setVisible(true);

    }

    public void makeInVis() {

        sizeLabel.setVisible(false);
        sizeText.setVisible(false);
        delayLabel.setVisible(false);
        delayText.setVisible(false);
        repetitionsLabel.setVisible(false);
        repetitionsText.setVisible(false);
        subSettings.setVisible(false);
        subSettings1.setVisible(false);
        advSettings.setVisible(true);
        endTraining.setVisible(true);
    }

    @FXML
    public void advSettings(ActionEvent event) {

        makeVis();

    }

    public void endScreen() {
        graphicsContext.clearRect(0, 0, 1112, 510);
        showCountDown.setText("Training finished");
        System.out.println("hi");
    }

    @FXML
    public void enterButtonActions(ActionEvent event) throws GameControllerException {
        if (sizeText.getText().isEmpty() || delayText.getText().isEmpty() || repetitionsText.getText().isEmpty()) {
            throw new exception.GameControllerException("Not all values are Inserted");
        } else if (StringUtils.isNumeric(delayText.getText()) && NumberUtils.isParsable(sizeText.getText()) && StringUtils.isNumeric(repetitionsText.getText())) {
            sizeMain = Double.parseDouble(sizeText.getText());
            delayMain = Integer.parseInt(delayText.getText());
            showAmount = Integer.parseInt(repetitionsText.getText());
            showAmountControl = Integer.parseInt(repetitionsText.getText());
            System.out.println("Success");
            makeInVis();

        } else {
            throw new exception.GameControllerException("Values aren't inserted Correctly");
        }
    }

    @FXML
    public void cancelButtonActions() {
        makeInVis();
    }

    @FXML
    public void endTraining(ActionEvent event) throws IOException {
        tl.stop();
        graphicsContext.clearRect(0, 0, 1112, 510);
        Stage primaryStage = (Stage) delayLabel.getScene().getWindow();
        primaryStage.close();

        FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("/fxml/sample.fxml"));
        Parent root1 = (Parent) fxmlLoader.load();
        Stage stage = new Stage();
        stage.setScene(new Scene(root1));
        stage.show();


        DateTimeFormatter dtf = DateTimeFormatter.ofPattern("dd/MM/yyyy");
        LocalDateTime now = LocalDateTime.now();
        System.out.println(showAmountControl + " " + amountMissed);
        System.out.println("User " + gameScoreList.getAverage() + " " + score.calculateAccuracy(showAmountControl, showAmountControl - amountMissed) + " " + dtf.format(now));
    }

    public void startProcedure() {
        graphicsContext.fillOval(100, 100, 50, 50);
        MouseEvent mouseEvent = new MouseEvent(MouseEvent.MOUSE_CLICKED, 100,
                100, 0, 0, MouseButton.PRIMARY, 1, true, true, true, true,
                true, true, true, true, true, true, null);
        clickAction(mouseEvent);

    }

    public void gameProgress() {
        KeyFrame frame = new KeyFrame(Duration.millis(delayMain), keyFrameEvent -> {
            timestamp = System.currentTimeMillis();
            makeRandomCircle();

        });
        if (showAmount == 1) {
            endScreen();
            System.out.println("hi:))");
        }
        tl.getKeyFrames().add(frame);
        tl.setCycleCount(showAmount);


    }

    private int setInterval() {
        if (interval == 0) {
            timer.cancel();
            showCountDown.setVisible(false);
//            startProcedure();
            startThisShit();

        }
        return --interval;
    }


    @Override
    public void initialize(URL url, ResourceBundle rb) {
        graphicsContext = canvas.getGraphicsContext2D();


    }
}
